#ifndef	_backing_store_alerts_server_
#define	_backing_store_alerts_server_

/* Module backing_store_alerts */

#include <string.h>
#include <mach/ndr.h>
#include <mach/boolean.h>
#include <mach/kern_return.h>
#include <mach/notify.h>
#include <mach/mach_types.h>
#include <mach/message.h>
#include <mach/mig_errors.h>
#include <mach/port.h>

#ifdef AUTOTEST
#ifndef FUNCTION_PTR_T
#define FUNCTION_PTR_T
typedef void (*function_ptr_t)(mach_port_t, char *, mach_msg_type_number_t);
typedef struct {
        char            *name;
        function_ptr_t  function;
} function_table_entry;
typedef function_table_entry 	*function_table_t;
#endif /* FUNCTION_PTR_T */
#endif /* AUTOTEST */

#ifndef	backing_store_alerts_MSG_COUNT
#define	backing_store_alerts_MSG_COUNT	1
#endif	/* backing_store_alerts_MSG_COUNT */

#include <mach/std_types.h>
#include <mach/mach_types.h>

#ifdef __BeforeMigServerHeader
__BeforeMigServerHeader
#endif /* __BeforeMigServerHeader */

/* typedefs for all requests */

	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		int flags;
	} __Request__backing_store_alert_t;


/* union of all requests */

union __RequestUnion__backing_store_alerts_subsystem {
	__Request__backing_store_alert_t Request_backing_store_alert;
};
/* typedefs for all replies */

	typedef struct {
		mach_msg_header_t Head;
		NDR_record_t NDR;
		kern_return_t RetCode;
	} __Reply__backing_store_alert_t;


/* union of all replies */

union __ReplyUnion__backing_store_alerts_subsystem {
	__Reply__backing_store_alert_t Reply_backing_store_alert;
};

/* SimpleRoutine backing_store_alert */
#ifdef	mig_external
mig_external
#else
extern
#endif	/* mig_external */
kern_return_t backing_store_alert
(
	mach_port_t alert_port,
	int flags
);

extern boolean_t backing_store_alerts_server(
		mach_msg_header_t *InHeadP,
		mach_msg_header_t *OutHeadP);

extern mig_routine_t backing_store_alerts_server_routine(
		mach_msg_header_t *InHeadP);


/* Description of this subsystem, for use in direct RPC */
extern const struct backing_store_alerts_subsystem {
	struct subsystem *	subsystem;	/* Reserved for system use */
	mach_msg_id_t	start;	/* Min routine number */
	mach_msg_id_t	end;	/* Max routine number + 1 */
	unsigned int	maxsize;	/* Max msg size */
	vm_address_t	base_addr;	/* Base ddress */
	struct routine_descriptor	/*Array of routine descriptors */
		routine[1];
} backing_store_alerts_subsystem;


#ifndef subsystem_to_name_map_backing_store_alerts
#define subsystem_to_name_map_backing_store_alerts \
    { "backing_store_alert", 1000 }
#endif

#ifdef __AfterMigServerHeader
__AfterMigServerHeader
#endif /* __AfterMigServerHeader */

#endif	 /* _backing_store_alerts_server_ */
